#include <complex.h>

#define PI  3.14159265
#define SQR(a)        ((a) * (a))
#define MIN(a, b)     (((a) < (b)) ? (a) : (b))
#define MAX(a, b)     (((a) > (b)) ? (a) : (b))
#define SUM(a, b)     (a + b)
#define SUMSQR(a, b)  ( ((a)*(a)) + ((b)*(b)) )
#define ROUND(a)      ((a)>0 ? (int)((a)+0.5) : -(int)(0.5-(a)))

#define ARANGE(a, b)        for ( i = 0; i < b; i++) a[i] = i
#define MAX_ARRAY(a, b, c)  c=a[0]; for ( i = 1; i < b; i++) if ( a[i] > a[i-1] ) c=a[i]
#define MIN_ARRAY(a, b, c)  c=a[0]; for ( i = 1; i < b; i++) if ( a[i] < a[i-1] ) c=a[i]
#define TOTAL(a, b, c)      c=0; for ( i = 0; i < b; i++) c += a[i]


float centroid(float *ps, int r, int c, int cpeak, float wl, float bw, float * wt);
float centroid_range(float *ps, int r, int c, int cpeak0, int cpeak1, float wl, float bw, float * wt);
void bootStrapping(float w[], float OPD[], float wMeanOPD[]);
void bootStrapping4(float w[], float OPD[], float wMeanOPD[]);
void solve_3se(double *a, double *b, double *c, double *y, double *x);
void champ_bs4 (double *w, double *OPD0, double *OPD1, double *DL0);
void bubbleSort(float *a, unsigned int n);
float sinc(float x);
float max(float* vector, int n);

int GDT_DFT(
 float *fringe, // fringe scan  I                                                                                                                                                               
 float *opds, // corresponding opds I                                                                                                                                                           
 int nsamples, // number of samples in scan   I                                                                                                                                                 
 double lambda, // central wavelength I                                                                                                                                                         
 double bandwidth, // spectral bandwidth I                                                                                                                                                      
 double delta_wavenumber,
 double *power_mean, // cross-fringe power                                                                                                                                                      
 double *noise_mean, // cross-fringe noise                                                                                                                                                      
 double complex *cplx_spectrum, //   dft   O                                                                                                                                                    
 double complex *cross_cplx_spectrum, //   product of dft by the dft shifted one sample  O                                                                                                      
 double *cross_powerspectrum, //   cross spectrum (pwr. spec. of cross_cplx_spectrum)  O                                                                                                        
 double complex *gdt_phasor // differential phasor                                                                                                                                              
 );

void dewarp(float *bias_matrix, int indx, float *biased_n, float *biased_x, float *biased_y, double *debiased_n, double *debiased_x, double *debiased_y);
